'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _levenshteinSort = require('levenshtein-sort');

var _levenshteinSort2 = _interopRequireDefault(_levenshteinSort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextDropdown = function (_Component) {
  _inherits(TextDropdown, _Component);

  function TextDropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextDropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextDropdown.__proto__ || Object.getPrototypeOf(TextDropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = { value: '' }, _this.componentWillMount = function () {
      return _this.filterValues(_this.props.defaultValue || '');
    }, _this.componentDidUpdate = function (prevProps) {
      return _this.props.defaultValue !== prevProps.defaultValue && _this.filterValue(_this.props.defaultValue || '');
    }, _this.handleValueChanged = function (event) {
      _this.filterValues(event.target.value);
      _this.props.onValueChanged && _this.props.onValueChanged(event.target.value);
    }, _this.handleValueSelected = function (event, value) {
      event.preventDefault();
      _this.filterValues(value);
      _this.props.onValueSelected(value);
    }, _this.filterValues = function (value) {
      var valueSelector = _this.props.valueSelector || function (value) {
        return value;
      };
      var maximumLength = _this.props.maximumLength || 10;

      var lowerValue = value.toLowerCase();
      var filteredValues = _this.props.values && _this.props.values.filter(function (value) {
        return valueSelector(value).toLowerCase().indexOf(lowerValue) !== -1;
      }).sort(function (a, b) {
        return (0, _levenshteinSort2.default)(lowerValue, valueSelector(a), valueSelector(b));
      }).slice(0, maximumLength);

      _this.setState({ value: value, filteredValues: filteredValues });
    }, _this.handleInputKeyDown = function (event) {
      if (event.key === 'ArrowDown') {
        // If the down arrow is pressed, start selecting items in the dropdown.
        var firstDropdownItem = document.getElementById(_this.props.id + '-text-dropdown').firstChild;
        firstDropdownItem && _this.focusElement(firstDropdownItem);
      } else if (event.key === 'Enter') {
        // If the user pressed ctrl-enter, let the user know.
        if (event.ctrlKey) {
          if (_this.state.value.length === 0) {
            // If the text box is empty, stop editing.
            _this.props.onControlEnter && _this.props.onControlEnter();
          } else {
            // If the text box is not empty, just complete the current value.
            _this.handleValueSelected(event, _this.state.value);
          }
          return;
        }

        // If the user pressed enter and there is a single item in the list, select it.
        if (_this.state.filteredValues && _this.state.filteredValues.length === 1) {
          _this.handleValueSelected(event, _this.state.filteredValues[0]);
        }
      }
    }, _this.focusElement = function (currentElement) {
      return _this.setState({ currentElement: currentElement }) || currentElement.focus();
    }, _this.handleDropdownKeyUp = function (event) {
      // If the up arrow is pressed and we are at the top of the list, focus the input.
      if (event.key === 'ArrowUp') {
        event.preventDefault();

        var currentElement = _this.state.currentElement;

        var previousElement = currentElement && currentElement.previousSibling;
        if (previousElement) {
          // If there is a previous item in the list, we are not trying to select the text input.
          _this.focusElement(previousElement);
          return;
        } else if (!currentElement) {
          // If this is the first item in the list, we are about to select the text input.
          _this.setState({ currentElement: document.activeElement });
          return;
        }

        var input = document.getElementById(_this.props.id + '-dropdown-input');
        input.focus();
      } else if (event.key === 'ArrowDown') {
        event.preventDefault();

        var nextElement = _this.state.currentElement.nextSibling;
        nextElement && _this.focusElement(nextElement);
      } else if (event.key === 'Tab') {
        _this.setState({ currentElement: document.activeElement.nextSibling });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextDropdown, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var valueSelector = this.props.valueSelector || function (value) {
        return value;
      };
      var _props = this.props,
          className = _props.className,
          id = _props.id,
          placeholder = _props.placeholder,
          name = _props.name;
      var _state = this.state,
          value = _state.value,
          filteredValues = _state.filteredValues;


      var results = filteredValues && filteredValues.map(function (value, index) {
        return _react2.default.createElement(
          'a',
          { key: index, className: 'dropdown-item', href: '#', tabIndex: '0', onClick: function onClick(e) {
              return _this2.handleValueSelected(e, value);
            } },
          valueSelector(value)
        );
      });

      // Don't show the dropdown if there is no text in the list, the list is empty or there is one exact match.
      var showDropdown = void 0;
      if (value.length === 0 || !filteredValues || !filteredValues.length) {
        showDropdown = false;
      } else {
        showDropdown = !filteredValues.some(function (v) {
          return valueSelector(v) === value;
        });
      }

      var anyMatches = filteredValues && filteredValues.length;

      return _react2.default.createElement(
        'div',
        { className: className + ' dropdown ' + (showDropdown ? 'show' : '') + ' ' + (!anyMatches && 'has-danger') },
        _react2.default.createElement('input', {
          id: id + '-dropdown-input',
          type: 'text',
          placeholder: placeholder || 'Enter',
          autoComplete: 'off',
          className: 'form-control',
          autoFocus: true,
          tabIndex: 0,
          name: name,
          value: value,
          onChange: this.handleValueChanged,
          onKeyDown: this.handleInputKeyDown,
          onKeyPress: function onKeyPress(e) {
            return e.stopPropagation();
          },
          required: true }),
        _react2.default.createElement(
          'ul',
          { id: id + '-text-dropdown', className: 'dropdown-menu', onKeyDown: this.handleDropdownKeyUp },
          results
        )
      );
    }
  }]);

  return TextDropdown;
}(_react.Component);

exports.default = TextDropdown;